/**
 *  \brief   VDU 
 *       Start_VDU_HD( unsigned Y0, unsigned Y1, int offset)
 *        CbCr.
 *  \param [in] Y0    
 *  \param [in] Y1    .  
 * Y1  Y0      CbCr.
 *  \param [in] offset    . 0 .
 *  \return  1
 *  
 *  \details VDU      .  
 *  Cb, Cr      Y   Cr  Cb.  
 *          0x80808080
 */
 int Start_VDU_SD( unsigned Y0, unsigned Y1);
 int Start_VDU_HD( unsigned Y0, unsigned Y1, int offset);
/**
 *  \brief status  
 *         
 *  
 *  \return  .  :
 *   0     (OSD)       
 *      
 *   1     (MVL)       
 *      
 *   2  "blank",    
 *   3       
 *   4       
 *  \details . dev6       
 */
 int vdu_status();
/**
 *  \brief IMG_Print8x15        Y only.
 *  \param [in] str   
 *  \param [in] img Parameter_Description
 *  \param [in] imgWidth Parameter_Description
 *  \param [in] x     . ..  4.
 *  \param [in] y     .
 *  \param [in] FGcolor     YCbCr
 *  \param [in] BGcolor     YCbCr
 *  \return    .
 *  
 *  \details        .
 *         
 *     .
 */
 int IMG_Print8x15( char *str, void* img, int imgWidth, int x, int y ,int FGcolor, int BGcolor);

 /**
 *  \brief      
 *    
 *  \param [in] x   
 *  \param [in] y   
 *  \param [in] L  
 *  \param [in] color    YCbCr
 *  \return  0
 *  
 *  \details    CbCr
 */
 int horl( int x, int y, int L, unsigned color);  // color=YCbCr
/**
 *  \brief      
 *  
 *  \param [in] x   
 *  \param [in] y   
 *  \param [in] L  
 *  \param [in] color    YCbCr
 *  \return  0
 *  
 *  \details    CbCr 
 */
 void verl( int x, int y, int L, unsigned color);  // color=YCbCr
/**
 *  \brief fillrect   
 *  
 *  \param [in] x0    
 *  \param [in] y0    
 *  \param [in] Nx  
 *  \param [in] Ny  
 *  \param [in] color    YCbCr
 *  \return 
 *  
 *  \details Details
 */
 void verl_Y( int x, int y, int L, int grey);//     Y
 void verl_cbcr( int x, int y, int L, int CbCr);//     CbCr
 
 void fillrect( int x0, int y0, int Nx, int Ny, unsigned color);

 /**
 *  \brief      
 *  
 *  \param [in] str  
 *  \param [in] x   
 *  \param [in] y   
 *  \param [in] FGcolor     YCbCr
 *  \param [in] BGcolor     YCbCr
 *  \return    
 *  
 *  \details -    16*28   8*15 
 *       2  .
 */void g8xfc( char *str, int x, int y ,int FGcolor, int BGcolor);
/**
 *  \brief fillBG   ,   Y
 *  16,   CbCr  128.
 *  
 *  \param [in] C_crt      Y
 *  \param [in] C_cbcr     CbCr
 *  
 *  \details  16  128 ,  
*/
void fillBG(int C_crt, int C_cbcr);
void fillBG();
 /**
 *  \brief    
 * start_VDU_HD( (unsigned)0xc0000000, (unsigned)0xc02f7600, 0);
 *  \details       Y0,Y1
 */
int  Start_VDU_HD();
/**
 *  \brief      8x15   .
 *  \param [in] str   
 *  \param [in] x     . ..  4.
 *  \param [in] y     .
 *  \param [in] FGcolor     YCbCr
 *  \param [in] BGcolor     YCbCr
 *  \return    .
 *  
*/
int g8xf( char *str, int x, int y ,int FGcolor, int BGcolor);

/**
 *  \brief       
 *  \param [in] str   
 *  \param [in] x     . ..  4.
 *  \param [in] y     .
 *  \param [in] FGcolor     YCbCr
 *  \param [in] BGcolor     YCbCr
 *  \return    .
 *  
 *  \details   815,     
 *   Y       .
*/
void g8xfc( char *str, int x, int y ,int FGcolor, int BGcolor);

/**
 *  \brief   Y,Cb,Cr   R,G,B
 *  \param [in] R  
 *  \param [in] B  
 *  \param [in] G  
 *  \details    . JPEG. Cr   
*/
int YCbCr( int R, int G, int B);
/**
 *  \brief   R,G,B   Y,Cb,Cr
 *  \param [in] Y   ( . 16)
 *  \param [in] Cb  Cb ( . 128)
 *  \param [in] Cr  Cr ( . 128)
 *  \details    . JPEG. Cr   
*/
int RGB( int Y, int Cb, int Cr);

 /**
 *  \brief pxl:      
 *    
 *  \param [in] x   
 *  \param [in] y   
 *  \param [in] color    YCbCr
 *  \return  0
 *  
 *  \details    CbCr
 */
unsigned pxl( int x, int y, int color); // color YCbCr

 /**
 *  \brief hex8:    
 *  \param [in]   int ???
 *  \return    .
 *  \details   ,   
 *  hex8     -.
*/
char *hex8( int x);

//#ifndef vdu_unit
//#define vdu_unit

//===============================================================
//void fill( unsigned *dst, int l, int color);

//#endif
