#include "vdu.h"
#include "vdu_Y_CbCr.h"
#include "string.h"
 extern unsigned rowsize,width,height,wH;
 extern unsigned rowsize,width,height,wH;
 extern vdubuf *vdu;  
 extern unsigned fontw8xf[960];

unsigned round( double x)
{ if (x<0.0) return (unsigned)(x-0.4999999999);  else
	return (unsigned)(x+0.4999999999);
}

int YCbCr( int R, int G, int B)//   cb,cr
{ double Y,Cb,Cr; int z,cr,cb,y; 
//     0..255
Y=0.299*R + 0.587*G + 0.114*B;
Cb=128 - 0.168736*R - 0.331264*G + 0.5*B;
Cr=128 + 0.5*R - 0.418688*G - 0.081312*B;
y=round(Y); cb=round(Cb); cr=round(Cr);	
z=(((y<<8)+cr)<<8) + cb;
return z;	
}
int RGB( int Y, int Cb, int Cr) // def by JPEG
{ int z,R,G,B,cr,cb;
  cr=Cr-128; cb=Cb-128;
  R=round(Y+1.402*cr);
  G=round(Y-0.34414*cb-0.71414*cr);
  B=round(Y+1.772*cb);
  z=(((R<<8)+G)<<8)+B; return z;	
} // RGB

unsigned pxl( int x, int y, int color) // color=YCbCr OK
{ static unsigned maskb[]={0, 0x000000ff, 0x0000ffff, 0x00ffffff};
  static unsigned maske[]={0xffffff00, 0xffffff00, 0xffff0000, 0xff000000};
  unsigned msk,m, k,kc, i,j,jb,Y,u; int L;
  L=1;
  m=rowsize*y;  k=m + (x>>2);  i=x & 3; j=i<<3;
  Y=color>>16;  jb=color&0xffff; 
  msk=~(255<<j);   u=Y<<j;
  vdu->crt[k]=(vdu->crt[k] & msk) | u;
// -----------  : --------------
  kc=rowsize*(y>>1);
  kc+=(x>>2);
  if (x & 2) //    32p 
  { vdu->Cb[kc]=(vdu->Cb[kc] & 0xffff) | (jb<<16); 
  } else
  { vdu->Cb[kc]=(vdu->Cb[kc] & 0xffff0000) | jb;
  }
	return 0;
} // pxl
char hexbuf[11];
char *hex8( int x)
{  int i,j,k;
	for (i=0; i<8; i++)	{ 
		j=x & 15;
		k=(j>9)? j+=87 : j+=48;
		hexbuf[7-i]=(char)k;
		x>>=4;
	}
	hexbuf[8]=0;
	return hexbuf;
}

int CbCr8xf( char *str, int x, int y ,int FGcolor, int BGcolor)
{ int i,k,q, ia;
	unsigned *t;
	unsigned *pcrt, *j;
	unsigned *f=fontw8xf; 
	unsigned a;
	k=(rowsize*y)>>1;
	j=(unsigned *)vdu->Cb + k + (x>>2); q=0; 
	for (k=0; k<15;k++)
	{   
		t=(unsigned *)str; 
		pcrt=(unsigned*)j;   j+=rowsize;
		while (k==k)
		{
			ia=*t & 255; if(ia==0) break;  
			a=f[ ia >>2]; 
			a>>=( ia & 3)<<3;
			for (i=0;i<2;i++)
			{  
				q<<=16; 
				if (a&1) q|=FGcolor; else q|=BGcolor;
				a>>=1; 
			}
			pcrt[3]=q;
			for (i=0;i<2;i++)
			{  
				q<<=16; 
				if (a&1) q|=FGcolor; else q|=BGcolor;
				a>>=1; 
			}
			pcrt[2]=q;
			for (i=0;i<2;i++)
			{  
				q<<=16; 
				if (a&1) q|=FGcolor; else q|=BGcolor;
				a>>=1; 
			}
			pcrt[1]=q;
			for (i=0;i<2;i++)
			{  
				q<<=16; 
				if (a&1) q|=FGcolor; else q|=BGcolor;
				a>>=1; 
			}
			pcrt[0]=q;
			t++;pcrt+=4;
		} 
		f+=64;
	}  
	i=x + (strlen(str)<<3); 
	return(i);
} // CbCr8xf 



void verl( int x, int y, int L, unsigned color)  // color=YCbCr
{ static unsigned maskb[]={0, 0x000000ff, 0x0000ffff, 0x00ffffff};
  static unsigned maske[]={0xffffff00, 0xffffff00, 0xffff0000, 0xff000000};
  unsigned msk,m, k,kc, i,i1,jb, Y,u,v; int Lc;
  Lc=L>>1;
  m=rowsize*y;  k=m + (x>>2);  i=x & 3;
  Y=color>>16;  jb=color & 0xffff; 
  msk=0xffffff00;  u=Y;
  for (i1=0;  i1<i;  i1++){msk=(msk<<8)|255;  u<<=8;}
  
  for (i=0; i<L; i++)
  {  vdu->crt[k]=(vdu->crt[k] & msk) | u;
     k+=rowsize;
  }
// -----------  : --------------
  v=rowsize;
  kc=(y>>1)*rowsize;
  kc+=(x>>2);
  for (i=0; i<Lc; i++)
  {
    if (x & 2) //    
    { vdu->Cb[kc]=(vdu->Cb[kc] & 0xffff) | (jb<<16); 
    }
//    if (Lc&3)
    { vdu->Cb[kc]=(vdu->Cb[kc] & 0xffff0000) | jb;
    }
     kc+=v;
  }
} // verl

void fillrect( int x0, int y0, int Nx, int Ny, unsigned color)
// color=YCbCr
{ int i,j;
    for (i=y0,j=i+Ny; i<j; i++)
    { horl ( x0, i, Nx, color);
    }	    
}
int Y8xf( char *str, int x, int y ,int FGcolor, int BGcolor)
{ 
	int i,k,q, ia;
	unsigned *t,FG,BG;
	unsigned *pY, *j, *p2;
	unsigned *f=fontw8xf; 
	unsigned a;
	FG=(FGcolor<<8)|FGcolor;	BG=(BGcolor<<8)|BGcolor;
	k=(rowsize*y);
	j=(unsigned *)vdu->crt + k + (x>>2); q=0; 
	for (k=0; k<15;k++)
	{   
		t=(unsigned *)str; 
		pY=(unsigned*)j;   j+=(rowsize<<1);  
		p2=pY+rowsize;
		while (k==k)
		{
			ia=*t & 255; if(ia==0) break;  
			a=f[ ia >>2]; 
			a>>=( ia & 3)<<3;
			for (i=0;i<2;i++)
			{  
				q<<=16; 
				if (a&1) q|=FG; else q|=BG;
					a>>=1; 
			}
			pY[3]=q;p2[3]=q;
			for (i=0;i<2;i++)
			{  
				q<<=16; 
				if (a&1) q|=FG; else q|=BG;
					a>>=1; 
			}
			pY[2]=q; p2[2]=q;
			for (i=0;i<2;i++)
			{  
				q<<=16; 
				if (a&1) q|=FG; else q|=BG;
					a>>=1; 
			}
			pY[1]=q;p2[1]=q;
			for (i=0;i<2;i++)
			{  
				q<<=16; 
				if (a&1) q|=FG; else q|=BG;
					a>>=1; 
			}
			pY[0]=q; p2[0]=q;
			pY+=4; p2+=4;
			t++;
		} 
		f+=64;
	}  
	i=x + (strlen(str)<<3); 
	return(i);
} // Y8xf 

void g8xfc( char *str, int x, int y ,int FGcolor, int BGcolor)
{ int k;
  k=strlen(str)<<3;
   Y8xf( str, x, y , FGcolor>>16,  BGcolor>>16);  //  double Y
CbCr8xf( str,x, y, FGcolor&0xffff, BGcolor&0xffff);// CbCr
}
